# Compte rendu analyse du ticket 1026


Paul-Louis Gomis
<br>
Lony Fauchoit

## 1. Le ticket

Ticket décrit dans la page https://scodoc.org/git/ScoDoc/ScoDoc/issues/1026.

```
Bulletins BUT: option ne pas afficher la moy. gen. indicative

Parfois les collègues veulent que cette moyenne soit calculée (eg pour classer les étudiants) mais pas affichée sur les bulletins.
```

## 2. Analyse du ticket

Classification : On peut considérer le ticket comme une maintenance 
évolutive car il s'agit de retirer quelque chose qui a été mis sur la page des bulletins BUT intentionnellement.

Nous avons demandé des précisions sur le ticket à notre professeur : Jean Carle, ainsi que sur le **discord** d'assistance : **ScoDoc Assistance** où nous avons pu converser avec l'administrateur : Emmanuel Viennet.

Il nous a été expliqué que le principe du ticket était d'avoir une option qui empêcherait d'afficher la moyenne sur le bulletin (à la demande des professeurs).

### 2.1 Modification demandé

Le changement est a faire sur la page de bulletin des étudiants en BUT :

![image](bulletin.png)

On veut que la note moyenne indicative puisse être calculé sans être affiché dans le bulletin

Le paramêtre permettant de changer le calcul de la moyenne est dans la page de parametrage du departement:

![image](Parametrage.png)

### 2.2 Analyse de la solution

Les paramètres sont stockés dans le fichier app/scodoc/sco_preferences.py
plus précisément dans le tableau self.prefs_definition

Le bulletin des BUT est dans le fichier app/static/js/releve-but.js
et la moyenne affiché via la variable data.semestre.notes.value ligne 235

### 2.3 Proposition de solution

Étant donné qu'il s'agit d'un **ajout de préférence**, (c'est une case qu'on souhaite cocher). Il faut une manière de la retrouver dans le code.

Nous avons donc ajouté une préférence dans le JSON se situant dans le fichier app/scodo/sco_preferences.py.
![alt text](code1.png)

De cette manière, nous avons un paramètre dont on peut vérifier la valeur et ainsi appliquer une simple opération telle qu'un IF.

Il s'agirait désormais d'ajouter dans le fichier app/static/js/releve-but.js la condition recherchée en utilisant notre paramètre booléen pour OUI ou NON afficher la moyenne générale

![alt text](code2.png)

### 3. Conclusions

La modification proposée fait une dizaine de lignes de code, dont la majorité faisant partie du JSON à modifier.

Il faut également prendre en compte que cette modification n'est pas une implémentation très poussée puisqu'elle se base sur le code précédemment écrit. 

Pas de nouveau fichier, de nouveaux imports, une modification très légère et très simple.